pid who;  /* global variable */
inline request(x, y, z) { /* perform statements atomically */
  atomic { x == y -> x = z; who = _pid }
}
inline release(x, y) {
  atomic { x = y; who = 0 }
}
active [2] proctype producer()
{
  do
    :: request(turn, P, N) ->  /* atomic compare and set */
       printf("Produce %d\n", _pid);  /* built-in _pid */
       assert(who == _pid);  /* I am producing */
       release(turn, C)  /* turn = C */
  od
}
